<template>
  <div>
    <div class="thing-list-wrapper">
      <div class="groups-drag-drop">
        <ul class="list">
          <li v-for="group in groupList" :key="group.id" class="item">
            <CCard>
              <CCardHeader>
                <div class="card-header-title">
                  <font-awesome-icon :icon="['fas', 'sitemap']" />
                  {{ group.name }}
                </div>
                <div class="card-header-actions">
                  <CSwitch
                    :id="group.id"
                    :checked="group.status === 1"
                    color="primary"
                    variant="3d"
                    shape="pill"
                    label-on="On"
                    label-off="Off"
                    @update:checked="onChangeStatusGroup"
                  />
                </div>
              </CCardHeader>

              <CCardBody>
                <draggable
                  :id="group.id"
                  v-model="group.things"
                  class="list-group"
                  group="thingList"
                  @end="onChangePositionThing"
                >
                  <div
                    v-for="thing in group.things"
                    :id="thing.id"
                    :key="thing.id"
                    class="list-group-item"
                    ghost-class="ghost"
                  >
                    <div class="txt-name">
                      <font-awesome-icon :icon="['fas', 'lightbulb']" class="width-1x" />
                      {{ thing.name }}
                    </div>
                    <ul class="row no-gutters box-detail">
                      <li class="col-6">
                        <CBadge :color="`${thing.status === 1 ? 'primary' : 'secondary'}`">
                          {{ thing.status === 1 ? 'ON' : 'OFF' }}
                        </CBadge>
                      </li>
                      <!-- <li class="col-4">
                        <font-awesome-icon :icon="['fas', 'check-circle']" class="width-1x" />
                        <span> 00 Things</span>
                      </li> -->
                      <li class="col-6 text-right">
                        <CSwitch
                          :id="thing.id"
                          :checked="thing.status === 1"
                          color="primary"
                          variant="3d"
                          shape="pill"
                          label-on="On"
                          label-off="Off"
                          @update:checked="onChangeStatusThing"
                        />
                      </li>
                    </ul>
                    <ul class="btns-action">
                      <li>
                        <div
                          class="btn text-primary"
                          title="Edit"
                          @click="onShowDetail(thing.id)"
                        >
                          <font-awesome-icon :icon="['fas', 'pencil-alt']" />
                        </div>
                      </li>
                      <li>
                        <div
                          class="btn text-danger"
                          title="Delete"
                          @click="onConfirmDelete(thing.id)"
                        >
                          <font-awesome-icon :icon="['fas', 'trash-alt']" />
                        </div>
                      </li>
                    </ul>
                  </div>
                </draggable>
                <div class="box-action">
                  <button class="btn-add-children" @click="onShowDetail(0)">
                    <font-awesome-icon :icon="['fas', 'plus-circle']" class="width-1x" />
                    Add another thing
                  </button>
                </div>
              </CCardBody>
            </CCard>
          </li>
        </ul>
      </div>
    </div>

    <app-delete-confirm-dialog
      ref="deleteConfirmDialog"
      :name="'thing'"
      @confirm="onDelete"
    />

    <thing-detail-modal
      :id="selectedId"
      ref="thingDetailModal"
      @modify="getGroupList"
    />
  </div>
</template>

<style lang="scss" scoped>
  .thing-list-wrapper {
    min-height: 200px;
  }
</style>

<script>
import draggable from 'vuedraggable'

import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'
import ThingDetailModal from '~/components/organisms/things/ThingDetailModal'

export default {
  components: {
    draggable,
    AppDeleteConfirmDialog,
    ThingDetailModal
  },

  data () {
    return {
      resourceTypeName: 'thing',
      groupList: [],
      selectedId: null
    }
  },

  mounted () {
    this.getGroupList()
  },

  methods: {
    /**
     * Call API get things
     */
    getGroupList () {
      this.$dam.getGroupList()
        .then((res) => {
          if (Array.isArray(res.data) && res.data.length) {
            this.groupList = res.data
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_GET', { name: 'group list' })
          )
        })
    },

    /**
     * Event when change position of thing
     *
     * @param {Object} event - Event object of drag and drop
     */
    onChangePositionThing (event) {
      if (!event.item.id || event.from.id === event.to.id) {
        return
      }

      const params = {
        id: +event.item.id,
        group_id: +event.to.id
      }
      this.$dam.updateThing(params)
        .then((res) => {
          this.$toast.success(
            this.$text.info('UPDATED', { name: this.resourceTypeName })
          )
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_UPDATE', { name: this.resourceTypeName })
          )

          this.getGroupList()
        })
    },

    /**
     * Event when change status of thing
     *
     * @return {Boolean} val - True if checkbox is checked, else false
     * @return {Object} event - Event object of checkbox
     */
    onChangeStatusThing (val, event) {
      if (!event.target.id) {
        return
      }

      const params = {
        id: +event.target.id,
        status: (val === true ? 1 : 0)
      }
      this.$dam.updateThing(params)
        .then((res) => {
          if (res && res.data && res.data.id) {
            // Change label state of current group on page
            this.groupList.forEach((group) => {
              group.things.map((thing) => {
                if (thing.id === res.data.id) {
                  thing.status = (val === true ? 1 : 0)
                  return thing
                }
              })
            })

            this.$toast.success(
              this.$text.info('UPDATED', { name: this.resourceTypeName })
            )
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_UPDATE', { name: this.resourceTypeName })
          )

          this.getGroupList()
        })
    },

    /**
     * Event when change status of group
     *
     * @return {Boolean} val - True if checkbox is checked, else false
     * @return {Object} event - Event object of checkbox
     */
    async onChangeStatusGroup (val, event) {
      if (!event.target.id) {
        return
      }

      try {
        let res = null

        if (val === true) {
          res = await this.$dam.groupOn({
            id: +event.target.id,
            status: 1
          })
        } else {
          res = await this.$dam.groupOff({
            id: +event.target.id,
            status: 0
          })
        }

        if (res && res.data && res.data.id) {
          // Change label and switch button state of all things on page
          this.groupList.forEach((group, idx) => {
            if (group.id === res.data.id) {
              this.groupList[idx].things.map((thing) => {
                thing.status = (val === true ? 1 : 0)
                return thing
              })
            }
          })

          this.$toast.success(
            this.$text.info('UPDATED', { name: 'group' })
          )
        }
      } catch (err) {
        console.error(err)

        this.$toast.error(
          this.$text.error('FAILED_TO_UPDATE', { name: 'group' })
        )
      }
    },

    /**
     * Open thing detail modal
     *
     * @param {Number} id - Current id
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.thingDetailModal.open()
    },

    /**
     * Open confirm delete
     * If confirm then call delete group
     * Else cancel
     *
     * @param {String} id - group id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * After the deletion confirmation dialog is confirmed
     */
    onDelete () {
      if (this.selectedId) {
        this.$dam.deleteThing({ id: this.selectedId })
          .then((_) => {
            this.$toast.success(
              this.$text.info('DELETED', { name: this.resourceTypeName })
            )

            this.getGroupList()
          })
          .catch((err) => {
            console.error(err)

            this.$toast.error(
              this.$text.error('FAILED_TO_DELETE', { name: this.resourceTypeName })
            )
          })
      }
    },

    /**
     * Set select id
     *
     * @param {Number} id - Thing id
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>
